## dbus 1.15.92

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

# we do not need to have WIN32 defined
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# detect version
include(MacrosMeson)
meson_init(meson.build)
meson_version(dbus)
set(DBUS_PATCH_VERSION 0)
set(VERSION "${DBUS_VERSION}")

if(WIN32)
    set(LANGUAGES C CXX)
else()
    set(LANGUAGES C)
endif()
project(dbus
    VERSION ${DBUS_VERSION}
    LANGUAGES C CXX
)

option(DBUS_BUILD_TESTS "enable unit test code" ON)
option(DBUS_ENABLE_INTRUSIVE_TESTS "enable tests that require insecure extra code in the library and binaries" OFF)

# replacement for AC_C_BIGENDIAN
include (TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

include(Macros)
string(TIMESTAMP DBUS_BUILD_TIMESTAMP "%Y%m%d%H%M" UTC)
set(BUILD_FILEVERSION ${DBUS_MAJOR_VERSION},${DBUS_MINOR_VERSION},${DBUS_MICRO_VERSION},${DBUS_PATCH_VERSION})
set(BUILD_TIMESTAMP ${DBUS_BUILD_TIMESTAMP})

########### basic vars ###############

if(UNIX AND CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(DBUS_LINUX 1)
endif()

include(GNUInstallDirs)

if(DBUSDIR)
    set(DBUS_INSTALL_DIR "${DBUSDIR}")
endif()
if($ENV{DBUSDIR})
    set(DBUS_INSTALL_DIR "$ENV{DBUSDIR}")
endif()

if(DBUS_INSTALL_DIR)
    set(CMAKE_INSTALL_PREFIX "${DBUS_INSTALL_DIR}" CACHE PATH "install prefix" FORCE)
else(DBUS_INSTALL_DIR)
    set(DBUS_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}")
endif()

set(DBUS_PREFIX ${DBUS_INSTALL_DIR})

set(prefix                   ${DBUS_INSTALL_DIR})
set(exec_prefix              ${prefix})
set(DBUS_MACHINE_UUID_FILE   ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/dbus/machine-id)
set(DBUS_BINDIR              ${CMAKE_INSTALL_FULL_BINDIR})
set(DBUS_DAEMONDIR           ${CMAKE_INSTALL_FULL_BINDIR})
set(DBUS_LOCALSTATEDIR       ${CMAKE_INSTALL_FULL_LOCALSTATEDIR})
set(DBUS_RUNSTATEDIR         ${CMAKE_INSTALL_FULL_RUNSTATEDIR})

# On Windows this is relative to where we put the bus setup, in
# ${datadir}/dbus-1. For simplicity, we only do this if
# ${sysconfdir} = ${prefix}/etc and ${datadir} = ${prefix}/share.
#
# On Unix, or on Windows with weird install layouts, it's the absolute path.
if(WIN32 AND ${CMAKE_INSTALL_FULL_SYSCONFDIR} STREQUAL ${prefix}/etc AND ${CMAKE_INSTALL_FULL_DATADIR} STREQUAL ${prefix}/share)
set(SYSCONFDIR_FROM_PKGDATADIR ../../etc)
set(DATADIR_FROM_PKGSYSCONFDIR ../../share)
else()
set(SYSCONFDIR_FROM_PKGDATADIR ${CMAKE_INSTALL_FULL_SYSCONFDIR})
set(DATADIR_FROM_PKGSYSCONFDIR ${CMAKE_INSTALL_FULL_DATADIR})
endif()

option(DBUS_RELOCATABLE "Attempt to make metadata relocatable" ON)
option(DBUS_ENABLE_PKGCONFIG "Enable pkgconfig support" ON)
option(ENABLE_VERBOSE_CONFIG "Be verbose on generating config files" OFF)

# For simplicity, we're not relocatable if CMAKE_INSTALL_LIBDIR
# is something more complicated (e.g. Debian multiarch);
# we don't want to have to compute how many ../ to add
if(CMAKE_INSTALL_LIBDIR STREQUAL "lib" OR CMAKE_INSTALL_LIBDIR STREQUAL "lib64")
    # We know we can use ../ to get to the prefix. Do nothing.
elseif(DBUS_RELOCATABLE)
    # Sorry, it's too hard to make this particular build relocatable
    message("Unusual CMAKE_INSTALL_LIBDIR: the generated package will not be relocatable.")
    set(DBUS_RELOCATABLE OFF)
endif()

# used in the C code
set(DBUS_LIBEXECDIR          ${CMAKE_INSTALL_FULL_LIBEXECDIR})
set(DBUS_DATADIR             ${CMAKE_INSTALL_FULL_DATADIR})

#enable building of shared library
set(BUILD_SHARED_LIBS ON)

set(INSTALL_TARGETS_DEFAULT_ARGS EXPORT DBus1Targets RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(CYGWIN)
    # TODO cygwin is not using WIN32 api
    set(WIN32)
endif()

# search for required packages
if(WIN32)
    # include local header first to avoid using old installed header
    set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} ${PROJECT_SOURCE_DIR})
    include(Win32Macros)
    addExplorerWrapper(${CMAKE_PROJECT_NAME})
endif()

if(NOT WIN32)
    set(CMAKE_THREAD_PREFER_PTHREAD ON)
    include(FindThreads)
endif()

option(DBUS_DISABLE_ASSERT "Disable assertion checking" OFF)

option(DBUS_ENABLE_STATS "enable bus daemon usage statistics" OFF)
option(ENABLE_TRADITIONAL_ACTIVATION "Enable traditional activation (without using systemd)" ON)

find_package(PkgConfig)

if(DBUS_LINUX)
    add_auto_option(ENABLE_SYSTEMD "build with systemd at_console support" AUTO)
    if (NOT PKG_CONFIG_FOUND)
        message(SEND_ERROR "pkg-config not found, this is required on Linux systems")
    endif()
    pkg_check_modules(SYSTEMD libsystemd>=209)
    if(NOT SYSTEMD_FOUND)
        pkg_check_modules(SYSTEMD libsystemd-login>=32 libsystemd-daemon>=32 libsystemd-journal>=32)
    endif()
    check_auto_option(ENABLE_SYSTEMD "systemd support" SYSTEMD_FOUND "systemd")
    if(ENABLE_SYSTEMD AND SYSTEMD_FOUND)
        set(DBUS_BUS_ENABLE_SYSTEMD ON)
        set(HAVE_SYSTEMD ${SYSTEMD_FOUND})
    endif()
    option(ENABLE_USER_SESSION "enable user-session semantics for session bus under systemd" OFF)
    set(DBUS_ENABLE_USER_SESSION ${ENABLE_USER_SESSION})

    add_path_option(WITH_SYSTEMD_SYSTEMUNITDIR "Directory for systemd service files" "")
    add_path_option(WITH_SYSTEMD_USERUNITDIR "Directory for systemd user service files" "")
    # get defaults
    pkg_check_modules(_SYSTEMD systemd)
    if(_SYSTEMD_FOUND)
        pkg_get_variable(_SYSTEMD_PREFIX systemd prefix)
        pkg_get_variable(_SYSTEMD_SYSTEMUNITDIR systemd systemdsystemunitdir)
        pkg_get_variable(_SYSTEMD_USERUNITDIR systemd systemduserunitdir)
        # remove install prefix, which may not match the current prefix
        string(REPLACE "${_SYSTEMD_PREFIX}/" "" DBUS_SYSTEMD_SYSTEMUNITDIR ${_SYSTEMD_SYSTEMUNITDIR})
        string(REPLACE "${_SYSTEMD_PREFIX}/" "" DBUS_SYSTEMD_USERUNITDIR ${_SYSTEMD_USERUNITDIR})
    else()
        set(DBUS_SYSTEMD_SYSTEMUNITDIR lib/systemd/system)
        set(DBUS_SYSTEMD_USERUNITDIR lib/systemd/user)
    endif()
    if(WITH_SYSTEMD_SYSTEMUNITDIR)
        set(DBUS_SYSTEMD_SYSTEMUNITDIR ${WITH_SYSTEMD_SYSTEMUNITDIR})
    endif()
    if(WITH_SYSTEMD_USERUNITDIR)
        set(DBUS_SYSTEMD_USERUNITDIR ${WITH_SYSTEMD_USERUNITDIR})
    endif()
endif()

if(NOT ENABLE_TRADITIONAL_ACTIVATION AND NOT (DBUS_LINUX AND DBUS_BUS_ENABLE_SYSTEMD))
    message(WARNING "\
Traditional activation and systemd activation are both disabled, so service \
activation (automatically starting services that receive messages) will not work. \
    ")
endif()

if(WIN32)
    set(FD_SETSIZE "8192" CACHE STRING "The maximum number of connections that can be handled at once")
endif()

find_package(EXPAT)
find_package(X11)
find_package(GLIB2)
if(GLIB2_FOUND)
    option(DBUS_WITH_GLIB "build with glib" ON)
endif()

# analogous to AC_USE_SYSTEM_EXTENSIONS in configure.ac
set(_GNU_SOURCE 1)

# do config checks
include(ConfigureChecks)

# make some more macros available
include(MacroLibrary)

if(MSVC)
    # controll folders in msvc projects
    include(ProjectSourceGroup)
    if(NOT GROUP_CODE)
        #set(GROUP_CODE split) #cmake default
        set(GROUP_CODE flat)
    endif()
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
    string(APPEND CMAKE_C_FLAGS_DEBUG " /FIconfig.h")
    string(APPEND CMAKE_C_FLAGS_RELEASE " /FIconfig.h")
    option(DBUS_MSVC_ANALYZE "Enable code analyzing for MSVC compiler: /analyze" OFF)
endif()

#
# setup warnings
#
if(NOT MSVC)
    # We're treating -fno-common like a warning: it makes the linker more
    # strict, because on some systems the linker is *always* this strict
    string(APPEND CMAKE_C_FLAGS " -fno-common")
    string(APPEND CMAKE_CXX_FLAGS " -fno-common")
endif()

option(ENABLE_WERROR "Unconditionally make all compiler warnings fatal" OFF)

if(MSVC)
    # Use the highest warning level
    if(WALL)
        set(WALL 1 CACHE STRING "all warnings"  FORCE)
        set(CMAKE_CXX_WARNING_LEVEL 4 CACHE STRING "warning level" FORCE)
        if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        else()
            string(APPEND CMAKE_CXX_FLAGS " /W4")
        endif()

        if(CMAKE_C_FLAGS MATCHES "/W[0-4]")
            string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
        else()
            string(APPEND CMAKE_C_FLAGS " /W4")
        endif()
    else()
        set(CMAKE_CXX_WARNING_LEVEL 3 CACHE STRING "warning level" FORCE)
    endif()

    # see https://msdn.microsoft.com/en-us/library/z78503e6.aspx
    # 4018 'expression' : signed/unsigned mismatch
    set(WARNINGS 4018)
    # 4090 'operation' : different 'modifier' qualifiers
    # 4101 'identifier' : unreferenced local variable
    # 4127 conditional expression is constant
    # 4244 'argument' : conversion from 'type1' to 'type2', possible loss of data
    set(WARNINGS_DISABLED 4090 4101 4127 4244)
    # 4002 too many actual parameters for macro 'identifier'
    # 4003 not enough actual parameters for macro 'identifier'
    # 4013 'function' undefined; assuming extern returning int
    # 4028 formal parameter 'number' different from declaration
    # 4031 second formal parameter list longer than the first list
    # 4047 operator' : 'identifier1' differs in levels of indirection from 'identifier2'
    # 4114 same type qualifier used more than once
    # 4133 'type' : incompatible types - from 'type1' to 'type2'
    set(WARNINGS_ERRORS 4002 4003 4013 4028 4031 4047 4114 4133)
    if(DBUS_MSVC_ANALYZE AND MSVC_VERSION GREATER 1600)
        string(APPEND CMAKE_C_FLAGS " /analyze")
    endif()
else()
    set(WARNINGS
        all
        array-bounds
        cast-align
        char-subscripts
        declaration-after-statement
        double-promotion
        duplicated-branches
        duplicated-cond
        extra
        float-equal
        format-nonliteral
        format-security
        format=2
        implicit-function-declaration
        init-self
        inline
        jump-misses-init
        logical-op
        missing-declarations
        missing-format-attribute
        missing-include-dirs
        missing-noreturn
        missing-prototypes
        nested-externs
        no-error=missing-field-initializers
        no-error=unused-label
        no-error=unused-parameter
        no-missing-field-initializers
        no-unused-label
        no-unused-parameter
        null-dereference
        old-style-definition
        packed
        pointer-arith
        pointer-sign
        redundant-decls
        restrict
        return-type
        shadow
        sign-compare
        strict-aliasing
        strict-prototypes
        switch-default
        switch-enum
        undef
        unused-but-set-variable
        write-strings
    )
    set(WARNINGS_C
        pointer-sign
    )
    set(WARNINGS_DISABLED
        error=inline
        error=overloaded-virtual
        error=missing-field-initializers
        error=null-dereference
        error=strict-aliasing
        error=unused-parameter
        inline
        unused-parameter
    )
    set(WARNINGS_ERRORS
    )
    if(ENABLE_WERROR)
        list(APPEND WARNINGS error)
    endif()
endif()

generate_compiler_warning_flags(
    RESULTVAR
        WARNINGS_CFLAGS
    WARNINGS
        ${WARNINGS}
        ${WARNINGS_C}
    DISABLED
        ${WARNINGS_DISABLED}
    ERRORS
        ${WARNINGS_ERRORS}
)
generate_compiler_warning_flags(
    CXX
    RESULTVAR
        WARNINGS_CXXFLAGS
    WARNINGS
        ${WARNINGS}
    DISABLED
        ${WARNINGS_DISABLED}
    ERRORS
        ${WARNINGS_ERRORS}
)

string(APPEND CMAKE_C_FLAGS " ${WARNINGS_CFLAGS}")
string(APPEND CMAKE_CXX_FLAGS " ${WARNINGS_CXXFLAGS}")

# let wine be able to show file and lines in backtrace
if(DBUS_USE_WINE)
    string(APPEND CMAKE_C_FLAGS " -gdwarf-2")

=== meson_options.txt ===
# Copyright © 2019-2020 Salamandar <felix@piedallu.me>
# SPDX-License-Identifier: MIT
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

option(
  'apparmor',
  type: 'feature',
  value: 'auto',
  description: 'AppArmor support'
)

option(
  'asserts',
  type: 'boolean',
  value: false,
  description: 'Include assertion checks'
)

option(
  'checks',
  type: 'boolean',
  value: true,
  description: 'Check for usage errors at public API'
)

option(
  'dbus_daemondir',
  type: 'string',
  description: 'Directory for installing the dbus-daemon'
)

option(
  'dbus_user',
  type: 'string',
  description: 'User for running the system dbus-daemon',
  value: 'messagebus'
)

option(
  'dbus_session_bus_connect_address',
  type: 'string',
  value: '',
  description: 'Fallback address for a session bus client to connect to',
)

option(
  'dbus_session_bus_listen_address',
  type: 'string',
  value: '',
  description: 'Default address for a session bus to listen on',
)

option(
  'doxygen_docs',
  type: 'feature',
  value: 'auto',
  description: 'Build Doxygen documentation'
)

option(
  'ducktype_docs',
  type: 'feature',
  value: 'auto',
  description: 'Build Ducktype documentation'
)

option(
  'intrusive_tests',
  type: 'boolean',
  value: false,
  description: 'Enable tests that require insecure extra code in the library and binaries'
)

option(
  'epoll',
  type: 'feature',
  value: 'auto',
  description: 'Use epoll(4) on Linux'
)

option(
  'inotify',
  type: 'feature',
  value: 'auto',
  description: 'Inotify support on Linux'
)

option(
  'installed_tests',
  type: 'boolean',
  value: false,
  description: 'Install automated tests for "as-installed" testing'
)

option(
  'kqueue',
  type: 'feature',
  value: 'auto',
  description: 'Kqueue support'
)

option(
  'launchd',
  type: 'feature',
  value: 'auto',
  description: 'Launchd auto-launch support'
)

option(
  'launchd_agent_dir',
  type: 'string',
  description: 'Directory to put the launchd agent'
)

option(
  'libaudit',
  type: 'feature',
  value: 'auto',
  description: 'Audit logging support for SELinux and AppArmor'
)

option(
  'message_bus',
  type: 'boolean',
  value: 'true',
  description: 'Enable dbus-daemon'
)

option(
  'modular_tests',
  type: 'feature',
  value: 'auto',
  description: 'Enable modular regression tests (requires GLib)'
)

option(
  'qch_dir',
  type: 'string',
  description: 'Directory to put the Qt help file'
)

option(
  'qt_help',
  type: 'feature',
  value: 'auto',
  description: 'Build Qt help documentation'
)

option(
  'relocation',
  type: 'feature',
  value: 'auto',
  description: 'Make pkg-config metadata relocatable'
)

# Deliberately not named runstatedir to avoid colliding with
# https://github.com/mesonbuild/meson/issues/4141
option(
  'runtime_dir',
  type: 'string',
  value: '',
  description: 'Directory for transient runtime state [default: LOCALSTATEDIR/run or /run]'
)

option(
  'selinux',
  type: 'feature',
  value: 'auto',
  description: 'SELinux support'
)

option(
  'session_socket_dir',
  type: 'string',
  description: 'Where to put sockets for the per-login-session message bus'
)

option(
  'solaris_console_owner_file',
  type: 'string',
  value: '',
  description: 'File to determine current console owner on Solaris (or "auto")'
)

option(
  'stats',
  type: 'boolean',
  value: true,
  description: 'Enable bus daemon usage statistics'
)

option(
  'system_pid_file',
  type: 'string',
  description: 'PID file for systemwide daemon'
)

option(
  'system_socket',
  type: 'string',
  description: 'UNIX domain socket for systemwide daemon'
)

option(
  'systemd_system_unitdir',
  type: 'string',
  description: 'Directory for systemd system service files'
)

option(
  'systemd_user_unitdir',
  type: 'string',
  description: 'Directory for systemd user service files'
)

option(
  'systemd',
  type: 'feature',
  value: 'auto',
  description: 'Systemd at_console support'
)

option(
  'test_socket_dir',
  type: 'string',
  description: 'Where to put sockets for make check'
)

option(
  'test_user',
  type: 'string',
  description: 'Unprivileged user for regression tests, other than root and the dbus_user',
  value: 'nobody'
)

option(
  'tools',
  type: 'boolean',
  value: 'true',
  description: 'Enable CLI tools such as dbus-send and dbus-monitor'
)

option(
  'traditional_activation',
  type: 'boolean',
  value: true,
  description: 'Build support for service activation without using SystemdService'
)

option(
  'user_session',
  type: 'boolean',
  value: true,
  description: 'Enable user-session semantics for session bus under systemd'
)

option(
  'valgrind',
  type: 'feature',
  value: 'disabled',
  description: 'Build with Valgrind instrumentation (note that this currently adds a hard dependency on valgrind)'
)

option(
  'verbose_mode',
  type: 'boolean',
  value: false,
  description: 'Support verbose debug mode'
)

option(
  'x11_autolaunch',
  type: 'feature',
  value: 'auto',
  description: 'Build with X11 auto-launch support'
)

option(
  'xml_docs',
  type: 'feature',
  value: 'auto',
  description: 'Build XML documentation'
)

option(
  'windows_output_debug_string',
  type: 'boolean',
  value: false,
  description: 'use OutputDebugString() to log messages to Windows debug port'
)

=== test/CMakeLists.txt ===

add_definitions(${DBUS_INTERNAL_CLIENT_DEFINITIONS})

include_directories(.)

set(DBUS_SESSION_BUS_LISTEN_ADDRESS ${TEST_LISTEN})

add_library(dbus-testutils STATIC
    disable-crash-handling.c
    disable-crash-handling.h
    test-utils.h
    test-utils.c
)
target_link_libraries(dbus-testutils ${DBUS_INTERNAL_LIBRARIES})

if(DBUS_ENABLE_INTRUSIVE_TESTS)
    add_subdirectory( name-test )
endif()

set(manual-dir-iter_SOURCES
    manual-dir-iter.c
)

set(test-service_SOURCES
    test-service.c
)

set(test-names_SOURCES
    test-names.c
)

set(break_loader_SOURCES
    break-loader.c
)

set(test-shell-service_SOURCES
    test-shell-service.c
)

set(test-shell_SOURCES
    shell-test.c
)

set(test-atomic_SOURCES
    internals/atomic.c
)

set(test-spawn_SOURCES
    spawn-test.c
)

set(test-exit_SOURCES
    test-exit.c
)

# We have to compile a separate copy of disable-crash-handling.c for
# test-segfault rather than using the libdbus-testutils library, because
# otherwise it would fail to link when using the AddressSanitizer.
set(test-segfault_SOURCES
    disable-crash-handling.c
    disable-crash-handling.h
    test-segfault.c
)

set(test-sleep-forever_SOURCES
    test-sleep-forever.c
)

set(manual-tcp_SOURCES
    manual-tcp.c
)

set(manual-paths_SOURCES
    manual-paths.c
)

add_helper_executable(manual-dir-iter ${manual-dir-iter_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
add_helper_executable(test-service ${test-service_SOURCES} dbus-testutils)
add_helper_executable(test-names ${test-names_SOURCES} dbus-testutils)
add_test_executable(test-shell ${test-shell_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
add_test_executable(test-string internals/strings.c dbus-testutils)
add_test_executable(test-printf internals/printf.c dbus-testutils)
add_helper_executable(test-privserver test-privserver.c dbus-testutils)
add_helper_executable(test-shell-service ${test-shell-service_SOURCES} dbus-testutils)
if(NOT WINCE AND ENABLE_TRADITIONAL_ACTIVATION)
    add_test_executable(test-spawn-oom internals/spawn-oom.c dbus-testutils)
endif()
if(ENABLE_TRADITIONAL_ACTIVATION)
    add_helper_executable(test-spawn ${test-spawn_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
endif()
add_helper_executable(test-exit ${test-exit_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
# the second argument of add_helper_executable() is a whitespace-separated
# list of source files and the third and subsequent arguments are libraries
# to link, hence the quoting here
add_helper_executable(test-segfault "${test-segfault_SOURCES}")
add_helper_executable(test-sleep-forever ${test-sleep-forever_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
add_helper_executable(manual-tcp ${manual-tcp_SOURCES} ${DBUS_INTERNAL_LIBRARIES})
add_helper_executable(manual-backtrace manual-backtrace.c dbus-1)
if(WIN32)
    add_helper_executable(manual-paths ${manual-paths_SOURCES} dbus-testutils)
endif()

if(DBUS_ENABLE_INTRUSIVE_TESTS)
    add_test_executable(test-atomic ${test-atomic_SOURCES} dbus-testutils)
    add_test_executable(test-hash internals/hash.c dbus-testutils)
    set_target_properties(test-hash PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    set(SOURCES
        internals/dbus-marshal-recursive-util.c
        internals/dbus-marshal-recursive-util.h
        internals/marshal-recursive.c
    )
    add_test_executable(test-marshal-recursive "${SOURCES}" dbus-testutils)
    set_target_properties(test-marshal-recursive PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    set(SOURCES
        internals/dbus-marshal-recursive-util.c
        internals/dbus-marshal-recursive-util.h
        internals/dbus-message-factory.c
        internals/dbus-message-factory.h
        internals/dbus-message-util.c
        internals/dbus-message-util.h
        internals/message-internals.c
    )
    add_test_executable(test-message-internals "${SOURCES}" dbus-testutils)
    set_target_properties(test-message-internals PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    set(SOURCES
        internals/address.c
        internals/dbus-auth-script.c
        internals/dbus-auth-script.h
        internals/dbus-auth-util.c
        internals/dbus-credentials-util.c
        internals/dbus-marshal-byteswap-util.c
        internals/dbus-marshal-recursive-util.c
        internals/dbus-marshal-recursive-util.h
        internals/dbus-marshal-validate-util.c
        internals/dbus-string-util.c
        internals/dbus-sysdeps-util.c
        internals/mempool.c
        internals/misc-internals.c
        internals/misc-internals.h
        internals/sha.c
    )
    add_test_executable(test-misc-internals "${SOURCES}" dbus-testutils)
    set_target_properties(test-misc-internals PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    add_test_executable(test-platform-mutex test-platform-mutex.c ${DBUS_INTERNAL_LIBRARIES} dbus-testutils)

    set(SOURCES bus/main.c bus/common.c bus/common.h)
    add_test_executable(test-bus "${SOURCES}" dbus-daemon-internal dbus-testutils ${EXPAT_LIBRARIES})
    # TODO: For full coverage this should be run with some specific
    # environment variable values: see dbus#541
    set_target_properties(test-bus PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    if(ENABLE_TRADITIONAL_ACTIVATION)
        set(SOURCES bus/normal-activation.c bus/common.c bus/common.h)
        add_test_executable(test-bus-normal-activation "${SOURCES}" dbus-daemon-internal dbus-testutils ${EXPAT_LIBRARIES})
        set_target_properties(test-bus-normal-activation PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})
    endif()


    set(SOURCES bus/dispatch-sha1.c bus/common.c bus/common.h)
    add_test_executable(test-bus-dispatch-sha1 "${SOURCES}" dbus-daemon-internal dbus-testutils ${EXPAT_LIBRARIES})
    set_target_properties(test-bus-dispatch-sha1 PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

    if(NOT WIN32)
        add_test_executable(test-bus-system bus/system.c launch-helper-internal dbus-testutils)
        add_test_executable(test-counter internals/counter.c dbus-testutils)
        if(ENABLE_TRADITIONAL_ACTIVATION)
            add_test_executable(test-bus-launch-helper-oom bus/launch-helper-oom.c launch-helper-internal dbus-testutils)
            add_helper_executable(dbus-daemon-launch-helper-for-tests bus/launch-helper-for-tests.c launch-helper-internal)

            set(SOURCES bus/failed-helper-activation.c bus/common.c bus/common.h)
            add_test_executable(test-bus-failed-helper-activation "${SOURCES}" dbus-daemon-internal dbus-testutils ${EXPAT_LIBRARIES})
            set_target_properties(test-bus-failed-helper-activation PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})

            set(SOURCES bus/helper-activation.c bus/common.c bus/common.h)
            add_test_executable(test-bus-helper-activation "${SOURCES}" dbus-daemon-internal dbus-testutils ${EXPAT_LIBRARIES})
            set_target_properties(test-bus-helper-activation PROPERTIES COMPILE_FLAGS ${DBUS_INTERNAL_CLIENT_DEFINITIONS})
        endif()
    endif()
endif()

if(DBUS_WITH_GLIB)
    message(STATUS "with glib test apps")

    add_library(dbus-testutils-glib STATIC
        test-utils-glib.h
        test-utils-glib.c
    )
    target_link_libraries(dbus-testutils-glib dbus-testutils ${DBUS_INTERNAL_LIBRARIES})

    add_definitions(
        ${GLIB2_DEFINITIONS}
    )
    include_directories(
        ${GLIB2_INCLUDE_DIR}
    )

    set(TEST_LIBRARIES ${DBUS_INTERNAL_LIBRARIES} dbus-testutils dbus-testutils-glib ${GLIB2_LIBRARIES})

    add_test_executable(test-assertions internals/assertions.c ${TEST_LIBRARIES})
    add_test_executable(test-corrupt corrupt.c ${TEST_LIBRARIES})
    add_test_executable(test-dbus-daemon dbus-daemon.c ${TEST_LIBRARIES})
    add_test_executable(test-dbus-daemon-eavesdrop dbus-daemon-eavesdrop.c ${TEST_LIBRARIES})
    add_test_executable(test-desktop-file internals/desktop-file.c ${TEST_LIBRARIES})
    add_test_executable(test-fdpass fdpass.c ${TEST_LIBRARIES})
    add_test_executable(test-header-fields header-fields.c ${TEST_LIBRARIES})
    add_test_executable(test-loopback loopback.c ${TEST_LIBRARIES})
    add_test_executable(test-marshal marshal.c ${TEST_LIBRARIES})
    add_test_executable(test-monitor monitor.c ${TEST_LIBRARIES})
    add_test_executable(test-refs internals/refs.c ${TEST_LIBRARIES})
    add_test_executable(test-relay relay.c ${TEST_LIBRARIES})
    add_test_executable(test-server-oom internals/server-oom.c ${TEST_LIBRARIES})
    add_test_executable(test-syntax syntax.c ${TEST_LIBRARIES})
    add_test_executable(test-sysdeps internals/sysdeps.c ${TEST_LIBRARIES})
    add_test_executable(test-syslog internals/syslog.c ${TEST_LIBRARIES})
    add_test_executable(test-uid-permissions uid-permissions.c ${TEST_LIBRARIES})
    add_test_executable(test-userdb internals/userdb.c ${TEST_LIBRARIES})
    add_helper_executable(manual-authz manual-authz.c ${TEST_LIBRARIES})
    add_helper_executable(manual-test-thread-blocking thread-blocking.c ${TEST_LIBRARIES})
endif()

### keep these in creation order, i.e. uppermost dirs first 
set(TESTDIRS
    data
    data/invalid-messages
    data/auth
    data/sha-1
    data/systemd-activation
    data/valid-config-files
    data/valid-config-files/basic.d
    data/valid-config-files/session.d
    data/valid-config-files-system
    data/valid-config-files-system/system.d
    data/valid-messages
    data/valid-service-files
    data/valid-service-files-system
    data/invalid-config-files
    data/invalid-config-files-system
    data/invalid-messages
    data/invalid-service-files-system
    data/equiv-config-files
    data/equiv-config-files/basic
    data/equiv-config-files/basic/basic.d
    data/equiv-config-files/entities
    data/equiv-config-files/entities/basic.d
)

foreach(DIR ${TESTDIRS})
    file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/${DIR})
endforeach()

### copy tests to builddir so that generated tests and static tests 
### are all in one place.
if(NOT ENABLE_VERBOSE_CONFIG)
    set(HINT " (use -DENABLE_VERBOSE_CONFIG=ON to see the list of files)")
endif()

message(STATUS "Copying test files to test directory${HINT}")

macro(dbus_configure_file _src _dest)
    configure_file(${_src} ${_dest} ${ARGN})
    if(ENABLE_VERBOSE_CONFIG)
        message("   generating ${_dest}")
    endif()
endmacro()

foreach(FILE_TYPE *.message-raw *.auth-script *.sha1 *.txt *.conf *.service)
    foreach(DIR ${TESTDIRS})
        file(GLOB FILES "${DIR}/${FILE_TYPE}" )
        foreach(FILE ${FILES})
            get_filename_component(FILENAME ${FILE} NAME)
            set(TARGET ${CMAKE_CURRENT_BINARY_DIR}/${DIR}/${FILENAME})
            dbus_configure_file(${FILE} ${TARGET} COPYONLY)
        endforeach()
    endforeach()
endforeach()

### generate test files
message(STATUS "Generating test files from templates into test directory${HINT}")

foreach(FILE_TYPE *.conf.in *.service.in)
    foreach(DIR ${TESTDIRS})
    file(GLOB FILES "${DIR}/${FILE_TYPE}" )
    foreach(FILE ${FILES})
        get_filename_component(FILENAME ${FILE} NAME)
        string(REGEX REPLACE "\\.in$" "" FILENAME ${FILENAME})
        set(TARGET ${CMAKE_CURRENT_BINARY_DIR}/${DIR}/${FILENAME})
        dbus_configure_file(${FILE} ${TARGET} @ONLY IMMEDIATE)
    endforeach()
    endforeach()
endforeach()

message(STATUS "Copying generated bus config files to test directory${HINT}")
dbus_configure_file(../bus/session.conf.in ${PROJECT_BINARY_DIR}/test/data/valid-config-files/session.conf @ONLY)
dbus_configure_file(../bus/system.conf.in ${PROJECT_BINARY_DIR}/test/data/valid-config-files-system/system.conf @ONLY)

=== debian/changelog ===
dbus (1.15.92-1) unstable; urgency=medium

  * New upstream release candidate (1.16.0 rc2)
    - Fixes a build regression on Hurd (Closes: #1089641)
  * d/rules: Update name of intrusive_tests option
  * d/control: Specifially document the debug build in dbus-tests as not
    for production use.
    This build enables options that are likely to be insecure, and
    certainly reduce performance and robustness. It should not be
    considered to be covered by security support.

 -- Simon McVittie <smcv@debian.org>  Wed, 11 Dec 2024 14:32:26 +0000

=== debian/control ===
Source: dbus
Section: admin
Priority: optional
Maintainer: Utopia Maintenance Team <pkg-utopia-maintainers@lists.alioth.debian.org>
Uploaders:
 Sjoerd Simons <sjoerd@debian.org>,
 Sebastian Dröge <slomo@debian.org>,
 Michael Biebl <biebl@debian.org>,
 Loic Minier <lool@dooz.org>,
 Simon McVittie <smcv@debian.org>,
Build-Depends:
 debhelper (>= 13.11.6~),
 debhelper-compat (= 13),
 dh-exec,
 libapparmor-dev [linux-any],
 libaudit-dev [linux-any],
 libcap-ng-dev [linux-any],
 libexpat-dev,
 libglib2.0-dev <!nocheck> <!noinsttest>,
 libnss-wrapper <!nocheck>,
 libselinux1-dev [linux-any],
 libsystemd-dev [linux-any],
 libx11-dev,
 meson,
 pkgconf,
 valgrind-if-available,
 xml-core,
 xmlto <!nodoc>,
Build-Depends-Indep:
 doxygen <!nodoc>,
 ducktype <!nodoc>,
 xsltproc <!nodoc>,
 yelp-tools <!nodoc>,
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/utopia-team/dbus.git
Vcs-Browser: https://salsa.debian.org/utopia-team/dbus
Homepage: https://dbus.freedesktop.org/
Rules-Requires-Root: no

Package: dbus
Architecture: any
Priority: standard
Provides:
 dbus-system-bus (= ${binary:Version}),
 default-dbus-system-bus,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 dbus-bin (= ${binary:Version}),
 dbus-daemon (= ${binary:Version}),
 dbus-system-bus-common (>= ${source:Version}),
 base-files (>= 13.4~) | usr-is-merged (>= 38~),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 default-dbus-session-bus | dbus-session-bus,
Multi-Arch: foreign
Description: simple interprocess messaging system (system message bus)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 D-Bus supports broadcast messages, asynchronous messages (thus
 decreasing latency), authentication, and more. It is designed to be
 low-overhead; messages are sent using a binary protocol, not using
 XML. D-Bus also supports a method call mapping for its messages, but
 it is not required; this makes using the system quite simple.
 .
 It comes with several bindings, including GLib, Python, Qt and Java.
 .
 This package provides a fully-functional D-Bus system bus with activation
 support, used for communication between system services, and depends on
 most of the other components of the reference implementation of D-Bus.
 .
 To provide a complete D-Bus session bus, install one of the packages
 that implement the dbus-session-bus virtual package, such as
 dbus-user-session. The recommended implementation is indicated by
 the default-dbus-session-bus virtual package.

Package: dbus-session-bus-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 dbus (<< 1.13.18-2~),
Replaces:
 dbus (<< 1.13.18-2~),
Description: simple interprocess messaging system (session bus configuration)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains the configuration files defining the behaviour of
 the D-Bus session bus, used for applications and per-user services.
 These are used by the reference implementation in the dbus package,
 and by the reimplementation in the dbus-broker package.
 .
 To provide a complete D-Bus session bus, install one of the packages
 that implement the dbus-session-bus virtual package, such as
 dbus-user-session. The recommended implementation is indicated by
 the default-dbus-session-bus virtual package.

Package: dbus-system-bus-common
Architecture: all
Multi-Arch: foreign
Depends:
 adduser,
 ${misc:Depends},
Breaks:
 dbus (<< 1.13.18-2~),
Replaces:
 dbus (<< 1.13.18-2~),
Description: simple interprocess messaging system (system bus configuration)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains the configuration files defining the behaviour of
 the D-Bus system bus, used for system services such as networking and
 storage management services. It is also responsible for creating the
 'messagebus' system user account used to run the system bus.
 These are used by the reference implementation in the dbus package,
 and by the reimplementation in the dbus-broker package.
 .
 To provide a complete D-Bus system bus, install one of the packages
 that implement the dbus-system-bus virtual package, such as dbus.
 The recommended implementation is indicated by the default-dbus-system-bus
 virtual package.

Package: dbus-bin
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 dbus (<< 1.13.18-2~),
Replaces:
 dbus (<< 1.13.18-2~),
Description: simple interprocess messaging system (command line utilities)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains the D-Bus command-line utilities such as dbus-send
 and dbus-monitor.

Package: dbus-daemon
Architecture: any
Multi-Arch: foreign
Depends:
 dbus-bin (= ${binary:Version}),
 dbus-session-bus-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 dbus (<< 1.13.18-2~),
Replaces:
 dbus (<< 1.13.18-2~),
Description: simple interprocess messaging system (reference message bus)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains dbus-daemon, the reference implementation of a
 D-Bus message bus, and dbus-run-session, a utility to start a temporary
 session dbus-daemon in a constrained environment or for automated tests.
 .
 To provide a complete D-Bus session bus, install one of the packages
 that implement the dbus-session-bus virtual package, such as
 dbus-user-session. The recommended implementation is indicated by
 the default-dbus-session-bus virtual package.

Package: dbus-1-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Suggests:
 libdbus-1-dev,
Description: simple interprocess messaging system (documentation)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains the API documentation for D-Bus, as well as
 the protocol specification.
 .
 See the dbus description for more information about D-Bus in general.

Package: dbus-tests
Build-Profiles: <!noinsttest>
Section: misc
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 dbus,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 gnome-desktop-testing,
Breaks:
 dbus-1-dbg (<< 1.11.10-2~),
Replaces:
 dbus-1-dbg (<< 1.11.10-2~),
Description: simple interprocess messaging system (test infrastructure)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package provides automated and manual tests for D-Bus, and the
 dbus-test-tool utility.
 .
 It also provides copies of the D-Bus libraries and executables compiled
 with extra test instrumentation, debug information and logging,
 installed into the /usr/lib/dbus-1.0/debug-build/ directory.
 This version is only suitable for debugging and testing on non-production
 systems: the additional instrumentation is likely to be insecure, and
 harms robustness and performance.
 .
 See the dbus package description for more information about D-Bus in general.

Package: dbus-udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Package-Type: udeb
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: simple interprocess messaging system (minimal runtime)
 D-Bus is a message bus, used for sending messages between applications.
 .
 This package is a minimal version of the dbus-daemon and dbus-x11
 packages, for use in the Debian installer. It can run a session bus,
 but is not suitable for use as a system bus.

Package: dbus-user-session
Architecture: linux-any
Multi-Arch: foreign
Provides:
 dbus-session-bus,
 default-dbus-session-bus,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 dbus-daemon (= ${binary:Version}) | dbus-broker,
 dbus-session-bus-common (>= ${source:Version}),
 libpam-systemd,
 systemd,
 ${misc:Depends},
Recommends:
 systemd-sysv,
Description: simple interprocess messaging system (systemd --user integration)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 On systemd systems, this package opts in to the session model in which
 a user's session starts the first time they log in, and does not end
 until all their login sessions have ended. This model merges all
 parallel non-graphical login sessions (text mode, ssh, cron, etc.), and up
 to one graphical session, into a single "user-session" or "super-session"
 within which all background D-Bus services are shared.
 .
 Multiple graphical sessions per user are not currently supported in this
 mode; as a result, it is particularly suitable for gdm, which responds to
 requests to open a parallel graphical session by switching to the existing
 graphical session and unlocking it.
 .
 To retain dbus' traditional session semantics, in which login sessions
 are artificially isolated from each other, remove this package and install
 dbus-x11 instead.
 .
 See the dbus package description for more information about D-Bus in general.

Package: dbus-x11
Architecture: any
Section: x11
Provides:
 dbus-session-bus,
 default-dbus-session-bus [!linux-any],
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 dbus-bin (= ${binary:Version}),
 dbus-daemon (= ${binary:Version}),
 dbus-session-bus-common (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: simple interprocess messaging system (X11 deps)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 This package contains the dbus-launch utility, which automatically
 launches one D-Bus session bus per X11 display per user. If the
 dbus-user-session package is also installed, it takes precedence over
 this package.
 .
 See the dbus description for more information about D-Bus in general.

Package: libdbus-1-3
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 dbus,
Section: libs
Description: simple interprocess messaging system (library)
 D-Bus is a message bus, used for sending messages between applications.
 Conceptually, it fits somewhere in between raw sockets and CORBA in
 terms of complexity.
 .
 D-Bus supports broadcast messages, asynchronous messages (thus
 decreasing latency), authentication, and more. It is designed to be
 low-overhead; messages are sent using a binary protocol, not using
 XML. D-Bus also supports a method call mapping for its messages, but
 it is not required; this makes using the system quite simple.
 .
 It comes with several bindings, including GLib, Python, Qt and Java.
 .
 The message bus daemon can be found in the dbus-daemon package.

Package: libdbus-1-3-udeb
Build-Profiles: <!noudeb>
Section: debian-installer
Package-Type: udeb
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: simple interprocess messaging system (minimal library)
 D-Bus is a message bus, used for sending messages between applications.
 .
 This package is a minimal version of the libdbus-1-3 package,
 for use in the Debian installer.

Package: libdbus-1-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Pre-Depends:

## dbus 1.16.0

=== debian/changelog ===
dbus (1.16.0-1) unstable; urgency=medium

  * New upstream stable release
  * d/gbp.conf: Use upstream/1.16.x branch to import stable releases
  * d/watch: Only watch for stable releases on this branch

 -- Simon McVittie <smcv@debian.org>  Mon, 16 Dec 2024 14:26:24 +0000
